#!/usr/bin/python

import xbmc,xbmcplugin
import xbmcgui
import sys
import urllib, urllib2
import re
import httplib
import urlparse
from os import path, system
from urllib2 import Request, URLError, urlopen
import xbmcaddon
from resources.lib import letwatch

host = "http://g10.x10host.com/test"
kids = host + '/Kids.txt'
movies = host + '/Movies.txt'
tv = host + '/Tv.txt'
recentMV = host + '/Recentmovieuploads.txt'
recentTV = host + '/RecentlyUploadedTv.txt'

thisPlugin = int(sys.argv[1])
addonId = "plugin.video.G10"
dataPath = xbmc.translatePath('special://profile/addon_data/%s' % (addonId))
addon = xbmcaddon.Addon()
path = addon.getAddonInfo('path')
pic = path+"/icon.png"
picNext = path+"/next.png"
picFanart = path+"/fanart.jpg"
progress = xbmcgui.DialogProgress()


def getUrl(url, referer=''):
    req = urllib2.Request(url)
    req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
    if referer:
      req.add_header('Referer', referer)
    response = urllib2.urlopen(req)
    link=response.read()
    response.close()
    return link
    
def playVideo(url):
    player = xbmc.Player()
    player.play(url)

def gedebug(strTxt):
    print '######################################################'
    print '### GEDEBUG: ' + str(strTxt)
    print '######################################################'
    return
    
def showMainMenu():
    addDirectoryItem("MOVIES", {"name":"MOVIES", "url":movies, "mode":1}, pic)
    addDirectoryItem("TV", {"name":"TV", "url":tv, "mode":1}, pic)
    addDirectoryItem("KIDS", {"name":"KIDS", "url":kids, "mode":1}, pic)
    addDirectoryItem("RECENT MOVIE UPLOADED", {"name":"RECENT MOVIE UPLOADED", "url":recentMV, "mode":1}, pic)
    addDirectoryItem("RECENT TV UPLOADED", {"name":"RECENT TV UPLOADED", "url":recentTV, "mode":1}, pic)

    xbmcplugin.endOfDirectory(thisPlugin)

def showList(url):
    content = getUrl(url)
    regex = '>(.+?)</.*?>.*?>(.+?)</.*?>.*?>(.+?)<'
    match = re.compile(regex).findall(content)

    for link, thumbnail, title in match:
      addDirectoryItem(title, {"name":title, "url":link, "mode":2}, thumbnail)

    xbmcplugin.endOfDirectory(thisPlugin)

def getStream(url):
    link = letwatch.resolve(url)
    playVideo(link)

std_headers = {
	'User-Agent': 'Mozilla/5.0 (X11; U; Linux x86_64; en-US; rv:1.9.2.6) Gecko/20100627 Firefox/3.6.6',
	'Accept-Charset': 'ISO-8859-1,utf-8;q=0.7,*;q=0.7',
	'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
	'Accept-Language': 'en-us,en;q=0.5',
}  

def addDirectoryItem(name, parameters={},pic=""):
    li = xbmcgui.ListItem(name,iconImage="", thumbnailImage=pic)
    li.setInfo( "video", { "Title" : name, "FileName" : name} )
    li.setProperty('Fanart_Image', picFanart)
    url = sys.argv[0] + '?' + urllib.urlencode(parameters)
    return xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]), url=url, listitem=li, isFolder=True)


def parameters_string_to_dict(parameters):
    ''' Convert parameters encoded in a URL to a dict. '''
    paramDict = {}
    if parameters:
        paramPairs = parameters[1:].split("&")
        for paramsPair in paramPairs:
            paramSplits = paramsPair.split('=')
            if (len(paramSplits)) == 2:
                paramDict[paramSplits[0]] = paramSplits[1]
    return paramDict

params = parameters_string_to_dict(sys.argv[2])
name =  str(params.get("name", ""))
url =  str(params.get("url", ""))
url = urllib.unquote(url)
mode =  str(params.get("mode", ""))

#### ACTIONS ####
if not sys.argv[2]:
    pass#print  "Here in default-py going in showContent"
    ok = showMainMenu()
else:
    if mode == str(1):
        ok = showList(url)
    if mode == str(2):
        ok = getStream(url)
